> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.nvidia.com/infra-controller/_mcp/server.

# Update Instance Type

PATCH https://nico-rest-api.nico.svc.cluster.local/v2/org/{org}/nico/instance/type/{instanceTypeId}
Content-Type: application/json

Update an Instance Type by ID.

Org must have an Infrastructure Provider entity that owns the Instance Type. User must have authorization role with `PROVIDER_ADMIN` suffix.

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/instance-type/update-instance-type

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NVIDIA Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/nico/instance/type/{instanceTypeId}:
    patch:
      operationId: update-instance-type
      summary: Update Instance Type
      description: >-
        Update an Instance Type by ID.


        Org must have an Infrastructure Provider entity that owns the Instance
        Type. User must have authorization role with `PROVIDER_ADMIN` suffix.
      tags:
        - subpackage_instanceType
      parameters:
        - name: org
          in: path
          description: Name of the Org
          required: true
          schema:
            type: string
        - name: instanceTypeId
          in: path
          description: ID of the Instance Type
          required: true
          schema:
            type: string
            format: uuid
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://nico-rest-api.nico.svc.cluster.local/v2/org/$ORG_NAME/nico/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InstanceType'
        '400':
          description: Error response when request data cannot be validated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NICoAPIError'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NICoAPIError'
      requestBody:
        description: ''
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/InstanceTypeUpdateRequest'
servers:
  - url: https://nico-rest-api.nico.svc.cluster.local
    description: Kubernetes Cluster
components:
  schemas:
    Labels:
      type: object
      additionalProperties:
        type: string
      title: Labels
    MachineCapabilityType:
      type: string
      enum:
        - CPU
        - Memory
        - Storage
        - Network
        - GPU
        - InfiniBand
        - DPU
      description: Type of the Capability
      title: MachineCapabilityType
    MachineCapability:
      type: object
      properties:
        type:
          $ref: '#/components/schemas/MachineCapabilityType'
          description: Type of the Capability
        name:
          type: string
          description: Name of the Capability component
        frequency:
          type:
            - string
            - 'null'
          description: Frequency of the Capability component, if available
        cores:
          type:
            - integer
            - 'null'
          description: Number of Cores in the Capability component, if applicable
        threads:
          type:
            - integer
            - 'null'
          description: Number of Threads in the Capability component, if applicable
        capacity:
          type:
            - string
            - 'null'
          description: Capacity of the Capability component, if applicable
        vendor:
          type:
            - string
            - 'null'
          description: Vendor of the Capability component, if available
        inactiveDevices:
          type: array
          items:
            type: integer
          description: A list of inactive devices
        count:
          type:
            - integer
            - 'null'
          description: Count of the Capability component
        deviceType:
          type:
            - string
            - 'null'
          description: Device Type of the Capability component, if available
      description: Describes capabilities of a Machine
      title: MachineCapability
    InstanceTypeUpdateRequest:
      type: object
      properties:
        name:
          type:
            - string
            - 'null'
        description:
          type:
            - string
            - 'null'
        labels:
          $ref: '#/components/schemas/Labels'
        machineCapabilities:
          type: array
          items:
            $ref: '#/components/schemas/MachineCapability'
      description: Request data to update an Instance Type
      title: InstanceTypeUpdateRequest
    Deprecation:
      type: object
      properties:
        attribute:
          type:
            - string
            - 'null'
          description: >-
            Name of the attribute that is deprecated. Omitted if queryParam or
            endpoint is being deprecated.
        queryParam:
          type:
            - string
            - 'null'
          description: >-
            Query parameter that is deprecated. Omitted if attribute or endpoint
            is being deprecated.
        endpoint:
          type:
            - string
            - 'null'
          description: >-
            API endpoint that is deprecated. Omitted if attribute or queryParam
            is being deprecated.
        replacedBy:
          type:
            - string
            - 'null'
          description: >-
            Name of the attribute, query parameter, or endpoint that replaces
            the deprecated item. Omitted if no replacement is available.
        takeActionBy:
          type: string
          format: date-time
          description: >-
            ISO datetime string for when the deprecated field will no longer be
            accepted or available in the API
        notice:
          type: string
          description: Message describing the deprecation
      description: >-
        Details of a particular deprecation in NVIDIA Infra Controller (NICo)
        API
      title: Deprecation
    MachineInstanceType:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: >-
            Deprecated: Use `machineId` when identifying a Machine/Instance Type
            association. This field will be removed on July 9th, 2026 0:00 UTC.
        machineId:
          type: string
        instanceTypeId:
          type: string
          format: uuid
        deprecations:
          type: array
          items:
            $ref: '#/components/schemas/Deprecation'
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Associates a machine with an Instance Type
      title: MachineInstanceType
    InstanceTypeAllocationStats:
      type: object
      properties:
        assigned:
          type: integer
          description: Total number of Machines assigned to this Instance Type
        total:
          type: integer
          description: >-
            Total number of Machines allocated to different Tenants for this
            Instance Type
        used:
          type: integer
          description: >-
            Total number of allocated Machines of this Instance Type currently
            being used by Tenants
        unused:
          type: integer
          description: >-
            Total number of allocated Machines of this Instance Type that is
            currently not being used by Tenants
        unusedUsable:
          type: integer
          description: >-
            Total number of allocated Machines of this Instance Type that is
            currently not in use but in Ready state, therefore can be
            provisioned by Tenant
        maxAllocatable:
          type: integer
          description: >-
            Maximum number of Machines of this Instance Type that can be
            allocated to a Tenant
      description: Allocation statistics for Instance Type
      title: InstanceTypeAllocationStats
    InstanceTypeStatus:
      type: string
      enum:
        - Pending
        - Registering
        - Ready
        - Deleting
        - Error
      description: Status values for Instance Type objects
      title: InstanceTypeStatus
    StatusDetail:
      type: object
      properties:
        status:
          type: string
        message:
          type:
            - string
            - 'null'
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Describes the details of a status transition for a resource
      title: StatusDetail
    InstanceType:
      type: object
      properties:
        id:
          type: string
          format: uuid
        name:
          type: string
        description:
          type:
            - string
            - 'null'
        controllerMachineType:
          type:
            - string
            - 'null'
        infrastructureProviderId:
          type: string
          format: uuid
        siteId:
          type: string
          format: uuid
        labels:
          $ref: '#/components/schemas/Labels'
        machineCapabilities:
          type: array
          items:
            $ref: '#/components/schemas/MachineCapability'
        machineInstanceTypes:
          type: array
          items:
            $ref: '#/components/schemas/MachineInstanceType'
          description: Available only for Providers
        allocationStats:
          $ref: '#/components/schemas/InstanceTypeAllocationStats'
          description: summary of machine counts by allocation status
        status:
          $ref: '#/components/schemas/InstanceTypeStatus'
        statusHistory:
          type: array
          items:
            $ref: '#/components/schemas/StatusDetail'
        deprecations:
          type: array
          items:
            $ref: '#/components/schemas/Deprecation'
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Instance types describe a set of machines that match a certain criteria
      title: InstanceType
    NiCoApiErrorSource:
      type: string
      enum:
        - nico
      description: Source of the error.
      title: NiCoApiErrorSource
    NiCoApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: NiCoApiErrorData
    NICoAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/NiCoApiErrorSource'
          description: Source of the error.
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/NiCoApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NVIDIA Infra Controller REST API
      title: NICoAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://nico-rest-api.nico.svc.cluster.local/v2/org/$ORG_NAME/nico/user/current

        ```

```

## Examples



**Request**

```json
{
  "description": "Updated version of the X3 Large family of machines",
  "labels": {
    "region": "portland",
    "env": "staging"
  },
  "machineCapabilities": [
    {
      "type": "CPU",
      "name": "Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz",
      "frequency": "3.0GHz",
      "cores": 18,
      "threads": 36,
      "count": 2
    }
  ]
}
```

**Response**

```json
{
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "name": "x3.large",
  "description": "Updated version of the X3 Large family of machines",
  "infrastructureProviderId": "5f2cc306-76e9-4fca-9186-950c9ef9a74e",
  "siteId": "72771e6a-6f5e-4de4-a5b9-1266c4197811",
  "labels": {
    "region": "portland",
    "env": "staging"
  },
  "machineCapabilities": [
    {
      "type": "CPU",
      "name": "Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz",
      "frequency": "3.0GHz",
      "cores": 18,
      "threads": 36,
      "count": 2
    }
  ],
  "status": "Pending",
  "statusHistory": [
    {
      "status": "Pending",
      "message": "Request received, pending processing",
      "created": "2019-08-24T14:15:22Z",
      "updated": "2019-08-24T14:15:22Z"
    }
  ],
  "deprecations": [
    {
      "queryParam": "includeMachineAssociation",
      "replacedBy": "includeMachineAssignment",
      "takeActionBy": "2023-07-26T00:00:00Z",
      "notice": "'includeMachineAssociation' has been deprecated in favor of 'includeMachineAssignment'. Please take action immediately."
    },
    {
      "attribute": "displayName",
      "takeActionBy": "2024-10-30T00:00:00Z",
      "notice": "'displayName' has been deprecated. Please take action immediately."
    }
  ],
  "created": "2019-08-24T14:15:22Z",
  "updated": "2019-08-24T14:15:22Z"
}
```

**SDK Code**

```python example-1
import requests

url = "https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/instance/type/instanceTypeId"

payload = {
    "description": "Updated version of the X3 Large family of machines",
    "labels": {
        "region": "portland",
        "env": "staging"
    },
    "machineCapabilities": [
        {
            "type": "CPU",
            "name": "Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz",
            "frequency": "3.0GHz",
            "cores": 18,
            "threads": 36,
            "count": 2
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript example-1
const url = 'https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/instance/type/instanceTypeId';
const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"description":"Updated version of the X3 Large family of machines","labels":{"region":"portland","env":"staging"},"machineCapabilities":[{"type":"CPU","name":"Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz","frequency":"3.0GHz","cores":18,"threads":36,"count":2}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go example-1
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/instance/type/instanceTypeId"

	payload := strings.NewReader("{\n  \"description\": \"Updated version of the X3 Large family of machines\",\n  \"labels\": {\n    \"region\": \"portland\",\n    \"env\": \"staging\"\n  },\n  \"machineCapabilities\": [\n    {\n      \"type\": \"CPU\",\n      \"name\": \"Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz\",\n      \"frequency\": \"3.0GHz\",\n      \"cores\": 18,\n      \"threads\": 36,\n      \"count\": 2\n    }\n  ]\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby example-1
require 'uri'
require 'net/http'

url = URI("https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/instance/type/instanceTypeId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"description\": \"Updated version of the X3 Large family of machines\",\n  \"labels\": {\n    \"region\": \"portland\",\n    \"env\": \"staging\"\n  },\n  \"machineCapabilities\": [\n    {\n      \"type\": \"CPU\",\n      \"name\": \"Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz\",\n      \"frequency\": \"3.0GHz\",\n      \"cores\": 18,\n      \"threads\": 36,\n      \"count\": 2\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java example-1
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/instance/type/instanceTypeId")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"description\": \"Updated version of the X3 Large family of machines\",\n  \"labels\": {\n    \"region\": \"portland\",\n    \"env\": \"staging\"\n  },\n  \"machineCapabilities\": [\n    {\n      \"type\": \"CPU\",\n      \"name\": \"Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz\",\n      \"frequency\": \"3.0GHz\",\n      \"cores\": 18,\n      \"threads\": 36,\n      \"count\": 2\n    }\n  ]\n}")
  .asString();
```

```php example-1
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/instance/type/instanceTypeId', [
  'body' => '{
  "description": "Updated version of the X3 Large family of machines",
  "labels": {
    "region": "portland",
    "env": "staging"
  },
  "machineCapabilities": [
    {
      "type": "CPU",
      "name": "Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz",
      "frequency": "3.0GHz",
      "cores": 18,
      "threads": 36,
      "count": 2
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp example-1
using RestSharp;

var client = new RestClient("https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/instance/type/instanceTypeId");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"description\": \"Updated version of the X3 Large family of machines\",\n  \"labels\": {\n    \"region\": \"portland\",\n    \"env\": \"staging\"\n  },\n  \"machineCapabilities\": [\n    {\n      \"type\": \"CPU\",\n      \"name\": \"Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz\",\n      \"frequency\": \"3.0GHz\",\n      \"cores\": 18,\n      \"threads\": 36,\n      \"count\": 2\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift example-1
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "description": "Updated version of the X3 Large family of machines",
  "labels": [
    "region": "portland",
    "env": "staging"
  ],
  "machineCapabilities": [
    [
      "type": "CPU",
      "name": "Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz",
      "frequency": "3.0GHz",
      "cores": 18,
      "threads": 36,
      "count": 2
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/instance/type/instanceTypeId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```